USE [PMX_VANHOVE_BE_PRD]
GO

/****** Object:  UserDefinedFunction [dbo].[PMX_FN_GetFirstSequenceForLocationsForItemForAdHocPicking]    Script Date: 30/11/2017 16:55:05 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO




ALTER FUNCTION [dbo].[PMX_FN_GetFirstSequenceForLocationsForItemForAdHocPicking]
(
	-- Add the parameters for the function here
	@pmxWhsCode nvarchar(50),
	@itemCode nvarchar(50),
	@batchToPick nvarchar(50),
	@pickListDocEntry int
	
)
RETURNS int
AS
BEGIN
	-- Declare the return variable here
	DECLARE @sequence int

	SET @sequence = 2147483647 --int(max)

	DECLARE @tblBatch AS TABLE (batchNumber nvarchar(50) COLLATE database_default, freeQuantity numeric(19,6), bbd dateTime)

	DECLARE @dueDate DateTime
	SET @dueDate = (SELECT TOP(1) DueDate FROM PMX_PLHE WHERE DocEntry = @pickListDocEntry)
	
	DECLARE @allowAdhocPickingOnBulk BIT
	IF not exists (select * From PMX_PAVA where ParameterCode = 'DPLCONTR.PC_PBAH' AND ParameterValue = 'True')
		BEGIN 
		SET @allowAdhocPickingOnBulk = 0
		END
	ELSE
		BEGIN
		SET @allowAdhocPickingOnBulk = 1
		END


	--build list of batches allowed (by quantity)
	INSERT INTO @tblBatch
	SELECT PMX_ITRI.BatchNumber, SUM(PMX_INVT.Quantity) - ISNULL(PMX_INLD.Quantity,0) AS FreeQty, PMX_ITRI.BestBeforeDate

	FROM PMX_INVT
	INNER JOIN PMX_OSEL ON PMX_INVT.StorLocCode = PMX_OSEL.Code
	INNER JOIN OITM ON PMX_INVT.ItemCode = OITM.ItemCode
	LEFT JOIN 
	(
		SELECT SUM(PMX_INLD.Quantity) AS Quantity, PMX_INLD.ItemTransactionalInfoKey, PMX_INLD.ItemCode, PMX_INLD.PmxWhsCode 
		FROM PMX_INLD 
		WHERE 
		PMX_INLD.InternalKey NOT IN 
			(SELECT PMX_INLD.InternalKey 
			FROM PMX_INLD 
			INNER JOIN PMX_PLLI
			ON PMX_PLLI.LineNum = PMX_INLD.BaseLine
			AND PMX_PLLI.DocEntry = PMX_INLD.BaseEntry
			AND PMX_INLD.BaseType = 'PMX_PLHE'
			WHERE PMX_INLD.BaseType = 'PMX_PLHE' 
			AND PMX_INLD.BaseEntry = @pickListDocEntry
			AND PMX_PLLI.PickListLineStatus IN ('N', 'R'))
		AND PMX_INLD.PmxWhsCode = @pmxWhsCode
		AND PMX_INLD.ItemCode = @itemCode
		--Exclude locking on locations that are not allowed (Like for instance for production)
		AND ISNULL(PMX_INLD.StorLocCode, '') NOT IN (SELECT Code FROM PMX_DISALLOWED_LOCATIONS_FOR_PICKING)
		GROUP BY PMX_INLD.ItemTransactionalInfoKey, PMX_INLD.ItemCode, PMX_INLD.PmxWhsCode
	) AS PMX_INLD ON PMX_INLD.ItemCode = PMX_INVT.ItemCode
	AND PMX_INLD.ItemTransactionalInfoKey = PMX_INVT.ItemTransactionalInfoKey
	AND PMX_INLD.PmxWhsCode = PMX_OSEL.PmxWhsCode


	LEFT JOIN PMX_ITRI ON PMX_ITRI.InternalKey = PMX_INVT.ItemTransactionalInfoKey

	WHERE PMX_INVT.ItemCode = @itemCode
	
	AND ( 
		PMX_ITRI.InternalKey IS NULL OR
		NOT EXISTS(SELECT PMX_TAIK.ItriKey
					FROM PMX_TAIK 
					INNER JOIN PMX_PLLI ON PMX_PLLI.DocEntry = PMX_TAIK.BaseEntry
					AND PMX_TAIK.BaseType = 'PMX_PLHE'
					AND PMX_PLLI.ItemCode = @itemCode
					WHERE PMX_TAIK.BaseEntry = @pickListDocEntry
		) OR
		PMX_ITRI.InternalKey IN 
		(
			SELECT PMX_TAIK.ItriKey
			FROM PMX_TAIK 
			INNER JOIN PMX_PLLI ON PMX_PLLI.DocEntry = PMX_TAIK.BaseEntry
			AND PMX_TAIK.BaseType = 'PMX_PLHE'
			AND PMX_PLLI.ItemCode = @itemCode
			WHERE PMX_TAIK.BaseEntry = @pickListDocEntry
		)
	)
	
	AND PMX_OSEL.PmxWhsCode = @pmxWhsCode
	AND (PMX_ITRI.BatchNumber = @batchToPick OR @batchToPick IS NULL)
	AND PMX_INVT.QualityStatusCode IN (SELECT Code FROM PMX_QYST WHERE CanBeShipped = 'Y')
	AND ISNULL(PMX_ITRI.BestBeforeDate, @dueDate + ISNULL(OITM.U_PMX_SLID, 0)) >= @dueDate  + ISNULL(OITM.U_PMX_SLID, 0)
	AND(PMX_INVT.StorLocCode NOT IN (
		--SELECT StorLocLostAndFound FROM PMX_OSWH WHERE StorLocLostAndFound IS NOT NULL
		SELECT [PMX_OSEL]."Code" FROM [PMX_OSEL] WHERE [PMX_OSEL]."TypeCode" IN ('PRODLINE', 'MOVLOC')  
		UNION SELECT [PMX_OSPL]."InputLocationCode" FROM [PMX_OSPL] WHERE [PMX_OSPL]."InputLocationCode" IS NOT NULL  
		UNION SELECT [PMX_OSPL]."PickToLocationCode" FROM [PMX_OSPL] WHERE [PMX_OSPL]."PickToLocationCode" IS NOT NULL  
		UNION SELECT [PMX_CBLU]."CanBeLinedUpLocationCode" FROM [PMX_CBLU] WHERE [PMX_CBLU]."CanBeLinedUpLocationCode" IS NOT NULL  
		UNION SELECT [PMX_OSWH]."StorLocLogCar" FROM [PMX_OSWH] WHERE [PMX_OSWH]."StorLocLogCar" IS NOT NULL  
		--UNION SELECT [PMX_OSWH]."StorLocRetItem" FROM [PMX_OSWH] WHERE [PMX_OSWH]."StorLocRetItem" IS NOT NULL  
		UNION SELECT [PMX_OSWH]."StorLocLostAndFound" FROM [PMX_OSWH] WHERE [PMX_OSWH]."StorLocLostAndFound" IS NOT NULL 
	)) 

	GROUP BY PMX_ITRI.BatchNumber, ISNULL(PMX_INLD.Quantity,0), PMX_ITRI.BestBeforeDate
	HAVING SUM(PMX_INVT.Quantity) - ISNULL( PMX_INLD.Quantity  ,0) >= 
	ISNULL(
		(SELECT SUM(PMX_PLLI.Quantity - PMX_PLLI.QtyPicked) 
			FROM PMX_PLLI 
			INNER JOIN [PMX_PLPL] ON [PMX_PLLI].[BaseType] = N'PMX_PLPH' 
			AND [PMX_PLLI].[BaseEntry] = [PMX_PLPL].[DocEntry] AND [PMX_PLLI].[BaseLine] = [PMX_PLPL].[LineNum] 
			LEFT JOIN [RDR1] ON [RDR1].[ObjType] = [PMX_PLPL].[BaseType] 
			AND [RDR1].[DocEntry] = [PMX_PLPL].[BaseEntry] AND [RDR1].[LineNum] = [PMX_PLPL].[BaseLine] 
			LEFT JOIN [INV1] ON [INV1].[ObjType] = [PMX_PLPL].[BaseType] AND [INV1].[DocEntry] = [PMX_PLPL].[BaseEntry] 
			AND [INV1].[LineNum] = [PMX_PLPL].[BaseLine] 

			WHERE 
			ISNULL( [RDR1].[U_PMX_AMBA], [INV1].[U_PMX_AMBA]) = 'N'
			AND PMX_PLLI.ItemCode = @itemCode AND PMX_PLLI.DocEntry = @pickListDocEntry
			AND PMX_PLLI.LineStatus = 'O')
	,0) OR PMX_ITRI.BatchNumber IS NULL


	DECLARE @tempDate dateTime
	SET @tempDate = GetDate()


	--Locations
	DECLARE @tbl AS TABLE (locationCode nvarchar(50) COLLATE database_default, seq int, isFullPallet char(1), freeQuantity numeric(19,6), bbd dateTime , quantity numeric(19,6), countLUID int, isPickLoc char(1))
	
	INSERT INTO @tbl
	SELECT DISTINCT [PMX_INVT].[StorLocCode] AS [StorLocCode] 
	, [PMX_OSSL].[Sequence], [PMX_LUID].[IsFullPallet], batch.freeQuantity, batch.bbd, SUM([PMX_INVT].[quantity]),
	 ISNULL(LuidOnLocation.CountLUID, 0), [PMX_OSSL].[IsPickLoc]

	FROM [PMX_INVT] INNER JOIN [PMX_OSSL] ON [PMX_OSSL].[Code] = [PMX_INVT].[StorLocCode] 
	INNER JOIN [PMX_OSEL] ON [PMX_OSEL].[Code] = [PMX_INVT].[StorLocCode] 
	INNER JOIN
	(
		SELECT COUNT( DISTINCT PMX_PLLI.LogUnitIdentKey) AS CountLUID, PMX_INVT.StorLocCode, PMX_INVT.ItemCode 
		from PMX_PLLI
		LEFT JOIN PMX_INVT 
		ON PMX_INVT.LogUnitIdentKey = PMX_PLLI.LogUnitIdentKey
		AND PMX_INVT.ItemCode = PMX_PLLI.ItemCode
		WHERE PMX_PLLI.DocEntry = @pickListDocEntry
		AND PMX_PLLI.PickListLineStatus IN ('N', 'R')
		GROUP BY PMX_INVT.StorLocCode, PMX_INVT.ItemCode
	) AS LuidOnLocation	ON PMX_INVT.StorLocCode = ISNULL(LuidOnLocation.StorLocCode, PMX_INVT.StorLocCode)
	AND PMX_INVT.ItemCode = ISNULL(LuidOnLocation.ItemCode, PMX_INVT.ItemCode)
	
	LEFT JOIN [PMX_LUID] ON [PMX_LUID].[InternalKey] = [PMX_INVT].[LogUnitIdentKey] 
	LEFT JOIN [PMX_ITRI] ON [PMX_ITRI].[InternalKey] = [PMX_INVT].[ItemTransactionalInfoKey] 
	LEFT JOIN @tblBatch batch ON ISNULL([PMX_ITRI].[BatchNumber],'') = ISNULL(batch.BatchNumber,'')
		AND ISNULL(batch.bbd, @tempDate) = ISNULL(PMX_ITRI.BestBeforeDate, @tempDate) AND batch.freeQuantity > 0

	LEFT JOIN (

	SELECT PMX_INLD.ItemCode, PMX_INLD.QualityStatusCode, PMX_INLD.ItemTransactionalInfoKey, PMX_INLD.LogUnitIdentKey,
	ISNULL(PMX_INLD.StorLocCode, PMX_INVT.StorLocCode) AS StorLocCode, SUM (PMX_INLD.Quantity) AS LockedQuantity 
	FROM PMX_INLD
	LEFT JOIN PMX_INVT ON PMX_INVT.LogUnitIdentKey = PMX_INLD.LogUnitIdentKey
	AND PMX_INVT.ItemCode = PMX_INLD.ItemCode
	AND PMX_INVT.QualityStatusCode = PMX_INLD.QualityStatusCode
	AND ISNULL(PMX_INVT.ItemTransactionalInfoKey, '')  = ISNULL(PMX_INLD.ItemTransactionalInfoKey, '')
	WHERE PMX_INLD.InvLockLevel in ('L','D')
			AND PMX_INLD.InternalKey NOT IN 
			(SELECT PMX_INLD.InternalKey 
			FROM PMX_INLD 
			INNER JOIN PMX_PLLI
			ON PMX_PLLI.LineNum = PMX_INLD.BaseLine
			AND PMX_PLLI.DocEntry = PMX_INLD.BaseEntry
			AND PMX_INLD.BaseType = 'PMX_PLHE'
			WHERE PMX_INLD.BaseType = 'PMX_PLHE' 
			AND PMX_INLD.BaseEntry = @pickListDocEntry
			AND PMX_PLLI.PickListLineStatus IN ('N', 'R'))
		AND PMX_INLD.PmxWhsCode = @pmxWhsCode
	GROUP BY
	PMX_INLD.ItemCode, PMX_INLD.QualityStatusCode, PMX_INLD.ItemTransactionalInfoKey, PMX_INLD.LogUnitIdentKey,
	PMX_INLD.StorLocCode, PMX_INVT.StorLocCode
	)
	AS Locking ON
	ISNULL(PMX_INVT.LogUnitIdentKey, '') = ISNULL(Locking.LogUnitIdentKey, '')
	AND PMX_INVT.ItemCode = Locking.ItemCode
	AND PMX_INVT.QualityStatusCode = Locking.QualityStatusCode
	AND ISNULL(PMX_INVT.ItemTransactionalInfoKey, '')  = ISNULL(Locking.ItemTransactionalInfoKey, '')
	AND PMX_INVT.StorLocCode = Locking.StorLocCode



	WHERE [PMX_OSEL].[PmxWhsCode] = @pmxWhsCode
	AND [PMX_INVT].[ItemCode] = @itemCode
	AND ( @allowAdhocPickingOnBulk = 1  OR [PMX_OSSL].IsPickLoc = 'Y')
	AND (PMX_ITRI.BatchNumber = @batchToPick OR @batchToPick IS NULL)

	AND (PMX_ITRI.BatchNumber IS NULL OR batch.freeQuantity IS NOT NULL)
	AND PMX_INVT.QualityStatusCode IN (SELECT Code FROM PMX_QYST WHERE CanBeShipped = 'Y')
	AND(PMX_INVT.StorLocCode NOT IN (
		--SELECT StorLocLostAndFound FROM PMX_OSWH WHERE StorLocLostAndFound IS NOT NULL
		SELECT [PMX_OSEL]."Code" FROM [PMX_OSEL] WHERE [PMX_OSEL]."TypeCode" IN ('PRODLINE', 'MOVLOC')  
		UNION SELECT [PMX_OSPL]."InputLocationCode" FROM [PMX_OSPL] WHERE [PMX_OSPL]."InputLocationCode" IS NOT NULL  
		UNION SELECT [PMX_OSPL]."PickToLocationCode" FROM [PMX_OSPL] WHERE [PMX_OSPL]."PickToLocationCode" IS NOT NULL  
		UNION SELECT [PMX_CBLU]."CanBeLinedUpLocationCode" FROM [PMX_CBLU] WHERE [PMX_CBLU]."CanBeLinedUpLocationCode" IS NOT NULL  
		UNION SELECT [PMX_OSWH]."StorLocLogCar" FROM [PMX_OSWH] WHERE [PMX_OSWH]."StorLocLogCar" IS NOT NULL  
		--UNION SELECT [PMX_OSWH]."StorLocRetItem" FROM [PMX_OSWH] WHERE [PMX_OSWH]."StorLocRetItem" IS NOT NULL  
		UNION SELECT [PMX_OSWH]."StorLocLostAndFound" FROM [PMX_OSWH] WHERE [PMX_OSWH]."StorLocLostAndFound" IS NOT NULL 

	)) 

	GROUP BY [PMX_INVT].[ItemCode], [PMX_ITRI].[InternalKey], [PMX_OSSL].[Sequence], [PMX_OSSL].[IsPickLoc], 
	[PMX_OSEL].[PmxWhsCode], [PMX_INVT].[StorLocCode], [PMX_LUID].[IsFullPallet], batch.freeQuantity, batch.bbd, [PMX_INVT].[LogUnitIdentKey], LuidOnLocation.CountLUID

	HAVING SUM ([PMX_INVT].[Quantity]) > ISNULL(SUM(Locking.[LockedQuantity]),0)  

	ORDER BY [PMX_OSSL].[IsPickLoc] DESC,[PMX_OSSL].[Sequence] DESC, batch.bbd, batch.freeQuantity, ISNULL(LuidOnLocation.CountLUID, 0) DESC, [PMX_LUID].[IsFullPallet], SUM([PMX_INVT].[quantity]) 

	SELECT TOP(1) @sequence = seq FROM @tbl  order by seq asc


	RETURN @sequence

END







GO

